######################################################
# Azure ML 接続情報
# Azure MLで公開したWebサービスのAPIキー
api_key <-  ""
# Azure MLで公開したWebサービスのURL
azureml_url <- ""
######################################################

name <- commandArgs(TRUE) # コマンドライン実行で引数を取得

# wavファイルの読み込み
wav <- tuneR::readWave(paste0(name, ".wav"), from = 0.9, to = 1, unit = "seconds")

f <- 8000 # サンプリング周波数
len_arr <- 200  # 必要なデータの長さを指定

data_spectrum <- seewave::spec(wav, f = f, plot=FALSE)[1:len_arr,2]
values <- as.list(round(data_spectrum, 10))

h = RCurl::basicTextGatherer()
hdr = RCurl::basicHeaderGatherer()

# APIに渡すデータ部分を生成
req = list(
  Inputs = list(
    "input1" = list(
      "ColumnNames" = list("V1", "V2", "V3", "V4", "V5", "V6", "V7", "V8", "V9", "V10", "V11", "V12", "V13", "V14", "V15", "V16", "V17", "V18", "V19", "V20", "V21", "V22", "V23", "V24", "V25", "V26", "V27", "V28", "V29", "V30", "V31", "V32", "V33", "V34", "V35", "V36", "V37", "V38", "V39", "V40", "V41", "V42", "V43", "V44", "V45", "V46", "V47", "V48", "V49", "V50", "V51", "V52", "V53", "V54", "V55", "V56", "V57", "V58", "V59", "V60", "V61", "V62", "V63", "V64", "V65", "V66", "V67", "V68", "V69", "V70", "V71", "V72", "V73", "V74", "V75", "V76", "V77", "V78", "V79", "V80", "V81", "V82", "V83", "V84", "V85", "V86", "V87", "V88", "V89", "V90", "V91", "V92", "V93", "V94", "V95", "V96", "V97", "V98", "V99", "V100", "V101", "V102", "V103", "V104", "V105", "V106", "V107", "V108", "V109", "V110", "V111", "V112", "V113", "V114", "V115", "V116", "V117", "V118", "V119", "V120", "V121", "V122", "V123", "V124", "V125", "V126", "V127", "V128", "V129", "V130", "V131", "V132", "V133", "V134", "V135", "V136", "V137", "V138", "V139", "V140", "V141", "V142", "V143", "V144", "V145", "V146", "V147", "V148", "V149", "V150", "V151", "V152", "V153", "V154", "V155", "V156", "V157", "V158", "V159", "V160", "V161", "V162", "V163", "V164", "V165", "V166", "V167", "V168", "V169", "V170", "V171", "V172", "V173", "V174", "V175", "V176", "V177", "V178", "V179", "V180", "V181", "V182", "V183", "V184", "V185", "V186", "V187", "V188", "V189", "V190", "V191", "V192", "V193", "V194", "V195", "V196", "V197", "V198", "V199", "V200"),
      "Values" = list(values)
    ),
    "input2" = list(
      "ColumnNames" = list("time"),
      "Values" = list(list(name))
    )
  ),
  GlobalParameters = setNames(rjson::fromJSON('{}'), character(0))
)

# リクエストの文字列を生成
body = enc2utf8(rjson::toJSON(req))
authz_hdr = paste('Bearer', api_key, sep=' ')
# APIを呼び出す
h$reset()
RCurl::curlPerform(url = azureml_url,
                   httpheader=c('Content-Type' = "application/json", 'Authorization' = authz_hdr),
                   postfields=body,
                   writefunction = h$update,
                   headerfunction = hdr$update,
                   verbose = TRUE
)
# APIの結果を処理
headers = hdr$value()
httpStatus = headers["status"]
if (httpStatus >= 400)
{
  print(paste("The request failed with status code:", httpStatus, sep=" "))

  print(headers)
}

# 結果を出力
result = h$value()
print(rjson::fromJSON(result))
